<?php
/*
Plugin Name: Ubernyms
Version: 2.6
Plugin URI: http://www.huddledmasses.org/category/development/wordpress/ubernyms-plugin/
Description: Wraps up the functionality of the Acronym Replacer, AutoLinker, and then some. Can replace anything with anything, and includes (optional) domTT powered tooltips.
Author: Joel Bennett
Author URI: http://www.HuddledMasses.org

Copyright (c) 2003
Released under the GPL license
http://www.gnu.org/licenses/gpl.txt

    This file is part of WordPress.
    WordPress is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// different types of ubernyms:
define("uttReplace",  "uttReplace");
define("uttJustLink", "uttJustLink" );
define("uttAbbreviation",   "uttAbbreviation" );
define("uttAcronym",  "uttAcronym" );
define("uttInitialism", "uttInitialism" );



function ubernyms_load_settings() {
   global $ubernyms_settings;
   
   if( empty($ubernyms_settings) ) {
      $ubernyms_settings = get_option("ubernyms_settings");
      if( empty($ubernyms_settings) ) {
         update_option("ubernyms_settings", array( true, true, true, true, true) );
      }
   }
}

function ubernyms_load() {
   global $ubernyms_collection;
   ubernyms_load_settings();

   if( empty($ubernyms_collection) ) {
      $ubernyms_collection = get_option("ubernyms_collection");
      // First, we define all the things we're going to replace, without using parenthesis or pipes (|)
      // ESPECIALLY note that they all end with commas EXCEPT the last one
      if( empty($ubernyms_collection) ) {
            //          $type,      $abbr,      $text,         $description = NULL, $english = FALSE, $makeLink = NULL, $appendLink = NULL
         $ubernyms_collection = array(
            new ubernym( uttInitialism,  "AOL",       "America Online", "Still the largest internet service provider in the world", false, NULL, "http://www.aol.com" ),
            new ubernym( uttAcronym,     "AIM",       "AOL Instant Messenger", "The most popular instant messaging service was originally for AOL members only.", false, NULL, "http://www.aim.com" ),
            new ubernym( uttAcronym,     "AJAX",      "Asynchronous Javascript And XML", "How we make web-pages truly dynamic", true, NULL, NULL ),
            new ubernym( uttInitialism,  "CSS",       "Cascading Style Sheets", "", true, NULL, "http://www.w3.org/Style/CSS/"),
            new ubernym( uttInitialism,  "HTML",      "HyperText Markup Language","Link to the spec:",false, NULL,"http://www.w3.org/MarkUp/"),
            new ubernym( uttInitialism,  "HTTP",      "HyperText Transfer Protocol","",false, NULL, NULL),
            new ubernym( uttInitialism,  "PDF",       "Portable Document Format","",false, NULL, NULL),
            new ubernym( uttInitialism,  "PHP",       "PHP: Hypertext Preprocessor","",false ,"http://www.php.net"),
            new ubernym( uttInitialism,  "PNG",       "Portable Network Graphics","", false, "http://www.w3.org/Graphics/PNG/", NULL),
            new ubernym( uttInitialism,  "RDF",       "Resource Description Framework", "", true ,"http://www.w3.org/RDF/", NULL),
            new ubernym( uttInitialism,  "RSS",       "Really Simple Syndication","",false, NULL, NULL),
            new ubernym( uttJustLink,    "ubernyms",  "A WordPress plugin", "The original acronym and autolinker plugins all rolled into one slick plugin with fancy tooltips and more.", false, NULL, "http://www.huddledmasses.org/category/development/wordpress/ubernyms-plugin/" ),
            new ubernym( uttInitialism,  "URL",       "Uniform Resource Locator","",false, NULL, NULL),
            new ubernym( uttInitialism,  "USB",       "Universal Serial Bus","",false, NULL, NULL),
            new ubernym( uttInitialism,  "VBS",       "Visual Basic Script", "", true, NULL, NULL),
            new ubernym( uttAcronym,     "VOIP",      "Voice Over Internet Protocol", "Allows you to make voice phone calls over the internet, which makes it much cheaper, and in many cases, free.", false, NULL, NULL),
            new ubernym( uttInitialism,  "W3C",       "World Wide Web Consortium","",false ,"http://www.w3.org/", NULL),
            new ubernym( uttAbbreviation,"WCAG",      "Web Content Accessibility Guidelines","",false ,"http://www.w3.org/TR/WAI-WEBCONTENT", NULL),
            new ubernym( uttAcronym,     "WYSIWYG",   "what you see is what you get","",false, NULL, NULL),
            new ubernym( uttInitialism,  "XHTML",     "eXtensible HyperText Markup Language - HTML reformulated as XML","",false ,"http://www.w3.org/MarkUp/", NULL),
            new ubernym( uttInitialism,  "XML",       "eXtensible Markup Language","",false ,"http://www.w3.org/XML/", NULL),
            new ubernym( uttAbbreviation,"XRX",       "Xerox (stock ticker symbol)","",false ,"http://www.google.com/finance?XRX", NULL),
            new ubernym( uttInitialism,  "XSL",       "eXtensible Stylesheet Language","",false ,"http://www.w3.org/Style/XSL/", NULL),
            new ubernym( uttInitialism,  "XSLT",      "eXtensible Stylesheet Language Transformation", "", true ,"http://www.w3.org/Style/XSL/", NULL),

/********************** Knitting Acronyms! ********************************/
            new ubernym( uttInitialism, "DPNs", "Double Pointed Needles", "", false, NULL, NULL),
            new ubernym( uttInitialism, "FOs", "Finished Object: What you just finished knitting, aka Finished Project", "", false, NULL, NULL),
            new ubernym( uttInitialism, "FPs", "Finished Project: What you just finished knitting, aka Finished Object", "", false, NULL, NULL),
            new ubernym( uttInitialism, "KIP", "Knit In Public", "", false, NULL, NULL),
            new ubernym( uttInitialism, "KAL", "Knit-along: When a bunch of knitters all knit the same thing, usually using a forum or a communal blog.", "", false, NULL, NULL),
            new ubernym( uttInitialism, "LYS", "Local Yarn Store", "", false, NULL, NULL),
            new ubernym( uttInitialism, "LYSO", "Local Yarn Store Owner", "", false, NULL, NULL),
            new ubernym( uttInitialism, "UFO", "Unfinished Object", "", "", false, NULL, NULL),
            new ubernym( uttInitialism, "WIP", "Work in Progress: What you're currently knitting", "", false, NULL, NULL),
            new ubernym( uttInitialism, "SnB", "Stitch 'N Bitch", "", false, NULL, NULL),
            new ubernym( uttInitialism, "VK", "Vogue Knitting", "", false, NULL, NULL),
            new ubernym( uttInitialism, "IK", "Interweave Knits: A popular knitting magazine.", "", false, NULL, NULL),
            new ubernym( uttInitialism, "BO", "Bind Off", "", false, NULL, NULL),
            new ubernym( uttInitialism, "inc", "Increase", "", false, NULL, NULL),
            new ubernym( uttInitialism, "psso", "Pass slipped stitch over", "", false, NULL, NULL),
            new ubernym( uttInitialism, "p2tog", "Purl two stitches together", "", false, NULL, NULL),
            new ubernym( uttInitialism, "k2tog", "Knit two stitches together", "", false, NULL, NULL),
            new ubernym( uttInitialism, "St st", "stockinette stitch", "", false, NULL, NULL),
            new ubernym( uttInitialism, "SAHM", "Stay At Home Mom", "", false, NULL, NULL),
            new ubernym( uttInitialism, "OSW", "One Skein Wonder", "A popular shrug pattern", false, NULL, NULL),
            new ubernym( uttInitialism, "TNNA", "The National NeedleArts Association", "", false, NULL, NULL),
            new ubernym( uttInitialism, "clap", "Clapotis", "", false, NULL, NULL),
            new ubernym( uttInitialism, "YH", "Yarn Harlot", "", false, NULL, NULL)
         );

         update_option("ubernyms_collection", $ubernyms_collection );
      }
   }
}

function ubernyms_make_config_page() {
	if ( function_exists('add_submenu_page') )
		add_submenu_page('plugins.php', 'Ubernyms Configuration', 'Ubernyms Configuration', 1, basename(__FILE__), 'ubernyms_config_page');
}

function ubernyms_config_page() {
   global $ubernyms_collection, $ubernyms_settings;
   ubernyms_load();

   if (isset($_POST['ubernyms_update'])) {
      ?><div class="updated"><p><strong>Settings updated!</strong></p><?php
      $ubernyms_settings[0] = isset($_POST['acronym']);
      $ubernyms_settings[1] = isset($_POST['domtt']);
      $ubernyms_settings[2] = isset($_POST['title']);
      $ubernyms_settings[3] = isset($_POST['caseinsensitive']);
      $ubernyms_settings[4] = isset($_POST['css']);
      update_option("ubernyms_settings", $ubernyms_settings );
      $utt_count = count($_POST['ubertt_type']);
                       
      array_multisort(  array_map('strtolower', $_POST['uber_abbr'] ), SORT_ASC, SORT_STRING,
                       $_POST['uber_abbr'],
                       $_POST['uber_text'],
                       $_POST['ubertt_type'],
                       $_POST['uber_description'],
                       $_POST['uber_english'],
                       $_POST['uber_makeLink'],
                       $_POST['uber_appendLink'] );
      $uttstored = 0;
      $ubernyms_collection = array();
      for( $utt = 0; $utt < $utt_count; $utt++ ) {
         if( $_POST['uber_abbr'][$utt] > "" && $_POST['uber_text'][$utt] > "" ) {
            $uttstored++;
            $ubernyms_collection[$utt] = new ubernym(
               $_POST['ubertt_type'][$utt],                                              // One of: uttReplace, uttAbbreviation, uttAcronym, uttInitialism
               htmlentities(stripslashes($_POST['uber_abbr'][$utt]), ENT_QUOTES),        // the search text
               htmlentities(stripslashes($_POST['uber_text'][$utt]), ENT_QUOTES),        // the replacement text (or tooltip text)
               htmlentities(stripslashes($_POST['uber_description'][$utt]), ENT_QUOTES), // additional text (in parenthesis, or in DomTT)
               ( $_POST['uber_english'][$utt] == "true" ),                               // TRUE to show the full description the first time the text appears
               htmlentities(stripslashes($_POST['uber_makeLink'][$utt]), ENT_QUOTES),    // URL to convert text into a link (leave NULL to not link)
               htmlentities(stripslashes($_POST['uber_appendLink'][$utt]), ENT_QUOTES)); // URL to append a (link) to the tooltip (or text if not using DomTT)
         }
      }
      update_option("ubernyms_collection", $ubernyms_collection );
      print( "<p><b>$uttstored</b> ubernyms stored." );
      ?></div><?php
   }?>

   <div class="wrap">
      <h2>Ubernyms Configuration</h2>
      <p>The purpose of <a href="http://www.huddledmasses.org/category/development/wordpress/ubernyms-plugin/">Ubernyms</a> 
      is to allow you configure a set of frequently used abbreviations that will be automatically
      coded nicely whenever you use them.  The goal is to make them visible in a way that
      is literate for both humans and computers.  In the future, I'll probably put the 
      list of acronyms here on this page and store them in the database, but for now you
      have to actually edit the plugin to add, remove or change ubernyms.</p>

      <p>There is a setting for each ubernym that lets you define if it is an 
      <a href="http://www.answers.com/acronym">acronym</a> or an 
      <a href="http://www.answers.com/initialism">initialism</a>, or just a plain old 
      abbreviation.  You can also specify special text that you want replaced completely,
      and even add links. In fact, you can add <abbr class="initialism">HTML</abbr> to the
      replacements or even to the tooltips if you use the DomTT method.</p>

      <h4>The default is for all settings to be checked</h4> 
      <form method="post" action="<?php print $_SERVER['PHP_SELF'] . '?page=' . basename(__FILE__); ?>">
         <fieldset id="Acronyms"><legend>Acronyms</legend>
         <p>
         The semantically <em>correct</em> thing to do is use the 
         <code>&lt;abbr&gt;</code> tag for all abbreviations, unless they are actually
         pronounceable words like <acronym>NATO</acronym> and <acronym>RADAR</acronym>, in which case you should use the 
         <code>&lt;acronym&gt;</code> tag.  The problem with this is that <abbr>IE6</abbr> doesn't
         correctly render the <code>&lt;abbr&gt;</code> tag at all. Of course, if you
         use the DomTT javascript and add style rules to your <abbr title="Cascading Style Sheets">CSS</abbr> for the span that this
         plugin adds, you can render it however you like!</p>
         <p><input type="checkbox" name="acronym"<?php if($ubernyms_settings[0]) print(' checked="checked"'); ?> /> Use semantically correct tags</p>
         </fieldset>
         
         <fieldset id="Javascript"><legend>Javascript</legend>
         <p>The <em>DomTT</em> fancy tooltips require a javascript, and depend on <abbr title="Cascading Style Sheets">CSS</abbr>
         for their styling. Because of that, you may want to use disable the <acronym>DOM</acronym> tooltips. If you don't, remember that
         Firefox (at least) will show the native tooltips over the <acronym>DOM</acronym> Tooltips, so you probably don't want to set the
         title attribute on the abbr tags, even though that makes them less useful to screen readers. And in addition, you 
         need to have rules in your <abbr title="Cascading Style Sheets">CSS</abbr> for the tooltips to display correctly. In other words, these three ought to be all 
         or nothing, unless you have your own custom <abbr title="Cascading Style Sheets">CSS</abbr>, or want my styles on your acronyms even without the <acronym>DOM</acronym> tooltips.</p>
         <p><input type="checkbox" name="domtt"<?php if($ubernyms_settings[1]) print(' checked="checked"'); ?> /> Use the DomTT script for tooltips</p>
         <p><input type="checkbox" name="title"<?php if($ubernyms_settings[2]) print(' checked="checked"'); ?> /> Don't use the title attribute</p>
         <p><input type="checkbox" name="css"<?php if($ubernyms_settings[4]) print(' checked="checked"'); ?> /> Add DomTT default CSS</p>
         </fieldset>
         
         <fieldset id="CaseSensitive"><legend>Case Sensitivity</legend>
         <p>By default Ubernyms operates without regard for case. This isn't 
         usually a problem because the replacement function prevents replacing letters
         in the middle of words. Personally, I find case-insensitive to be more useful 
         since it allows me to autolink certain normal words, and put abbreviations for
         words like Canada as <abbr>CA</abbr> or <abbr>Ca</abbr>. At any rate, if you want to make it case-sensitive, 
         feel free to uncheck this setting.</p>
         <input type="checkbox" name="caseinsensitive"<?php if($ubernyms_settings[3]) print(' checked="checked"'); ?> /> Ignore case.
         </fieldset>


         <fieldset id="Ubernyms"><legend>Ubernyms</legend>
         <p>The ubernyms that are configured are listed below. To remove one, simly delete it's Text and Definition.</p>
         <p>The meaning of each setting is as follows:</p>
         <dl>
            <dt>Type</dt><dd>The type of ubernym to create.
               <dl>
                  <dt>Replace Text</dt><dd>Replace the <kbd>Text</kbd> with the <kbd>Definition</kbd>. No tooltip, but links work.</dd>
                  <dt>Just Link</dt><dd>Just create a link with a tooltip.</dd>
                  <dt>Abbreviation</dt><dd>An <kbd>abbr</kbd> tag (surrounded with a <kbd>span</kbd> tag if you're using DomTT tooltips)</dd>
                  <dt>Acronym</dt><dd>An <kbd>acronym</kbd> tag (surrounded with a <kbd>span</kbd> tag if you're using DomTT tooltips)</dd>
                  <dt>Initials</dt><dd>An <kbd>abbr</kbd> tag with the <kbd>class</kbd> set to <em>initialism</em> (surrounded with a <kbd>span</kbd> tag if you're using DomTT tooltips)</dd>                                      
               </dl>
            </dd>
            <dt>Text</dt><dd>The text to replace</dd>
            <dt>Definition</dt><dd>The definition for the abbreviation, or the replacement text</dd>
            <dt>Description</dt><dd><i>Optional</i>. A longer description of the term (used in DomTT tooltips, if present)</dd>
            <dt>English</dt><dd><i>Optional</i>. In normal english, the first time we use an acronym our audience wouldn't recognize, we spell out the full definition in the text. If you enable this option, ubernyms will do the same.</dd>
            <dt>Make Link</dt><dd><i>Optional</i>. A URL to use to create a link on the page.</dd>
            <dt>Append Link</dt><dd><i>Optional</i>. A URL to use to create a link in the tooltip, or to append on the end, if not using DomTT (You probably don't want to use this if you're not using DomTT)</dd>
         </dl>
         <table>
            <tr>
               <th>Type</th> <th>Text</th> <th>Definition</th> <th>Description</th> <th>English</th> <th>Make Link</th> <th>Append Link</th>
            </tr>
         <?php
            $ubercount = 0;
            foreach($ubernyms_collection as $tooltip) {
               $ubercount++; 
            ?>               
            <tr>
               <td>
                  <select name="ubertt_type[]">
                     <option value="uttReplace"  <?php if( uttReplace == $tooltip->type) {print 'selected="selected"';} ?>>Replace Text</option>
                     <option value="uttJustLink" <?php if( uttJustLink == $tooltip->type) {print 'selected="selected"';}?>>Just Link</option>
                     <option value="uttAbbreviation"   <?php if( uttAbbreviation == $tooltip->type) {print 'selected="selected"';}  ?>>Abbreviation</option>
                     <option value="uttAcronym"  <?php if( uttAcronym == $tooltip->type) {print 'selected="selected"';} ?>>Acronym</option>
                     <option value="uttInitialism" <?php if( uttInitialism == $tooltip->type) {print 'selected="selected"';}?>>Initials</option>
                  </select>
               </td><td>
                  <input name="uber_abbr[]" size="10" type="text" value="<?php print($tooltip->abbr);?>"/>
               </td><td>
                  <input name="uber_text[]" size="25" type="text" value="<?php print($tooltip->text);?>"/>
               </td><td>
                  <input name="uber_description[]" size="50" type="text" value="<?php print($tooltip->description);?>"/>
               </td><td>
                  <select name="uber_english[]">
                     <option value="false" >False</option>
                     <option value="true" style="font-weight: bold;" <?php if( $tooltip->english ) {print 'selected="selected"';} ?>>True</option>
                  </select>
               </td><td>
                  <input name="uber_makeLink[]" size="25" type="text" value="<?php print($tooltip->makeLink);?>"/>
               </td><td>
                  <input name="uber_appendLink[]" size="25" type="text" value="<?php print($tooltip->appendLink);?>"/>
               </td>
            </tr>
            <?php if( ($ubercount % 10) == 0 ) { ?>
            <tr>
               <th>Type</th> <th>Text</th> <th>Definition</th> <th>Description</th> <th>English</th> <th>Make Link</th> <th>Append Link</th>
            </tr>
            <?php } 
            } ?>
            <tr>
               <th colspan="2" style="text-align:left;" ><h3 style="color: navy;">Add new acronyms:</h3></th>
            </tr>
            <tr>
               <th>Type</th> <th>Text</th> <th>Definition</th> <th>Description</th> <th>English</th> <th>Make Link</th> <th>Append Link</th>
            </tr>
            <?php
            for($i=0; $i < 5; $i++) { $ubercount++;
            ?>               
            <tr>
               <td>
                  <select name="ubertt_type[]">
                     <option value="uttReplace"     >Replace Text</option>
                     <option value="uttJustLink"    >Just Link</option>
                     <option value="uttAbbreviation" selected="selected" >Abbreviation</option>
                     <option value="uttAcronym"     >Acronym</option>
                     <option value="uttInitialism"  >Initials</option>
                  </select>
               </td><td>
                  <input name="uber_abbr[]" size="10" type="text" value="" class="mandatory"/>
               </td><td>
                  <input name="uber_text[]" size="25" type="text" value="" class="mandatory"/>
               </td><td>
                  <input name="uber_description[]" size="50" type="text" value=""/>
               </td><td>
                  <select name="uber_english[]">
                     <option value="false" >False</option>
                     <option value="true" style="font-weight: bold;">True</option>
                  </select>
               </td><td>
                  <input name="uber_makeLink[]" size="25" type="text" />
               </td><td>
                  <input name="uber_appendLink[]" size="25" type="text" />
               </td>
            </tr>
            <?php } ?>
            
         </table>
         </fieldset>
         <br />
         <input type="submit" name="ubernyms_update" value="Set Options" />
      </form>
   </div>
   <?php
}

// include the uber tooltips script

function ubertt_tooltip_script() {
   global $ubernyms_collection, $ubernyms_settings;
   ubernyms_load_settings();

   if( $ubernyms_settings[4] ) { ?>
   <link rel="stylesheet" type="text/css" media="screen" href="<?php print get_settings('siteurl'); ?>/wp-content/plugins/ubernyms/ubernyms.css" />
   <?php 
   }
   if( $ubernyms_settings[1] ) { 
      if( !defined("HMO_DOMTT_JAVASCRIPT") ) { 
         define("HMO_DOMTT_JAVASCRIPT", "The DomTT script has been included");
  
         if( $ubernyms_settings[4] ) { ?>
   <link rel="stylesheet" type="text/css" media="screen" href="<?php print get_settings('siteurl'); ?>/wp-content/plugins/ubernyms/domTT/domTT.css" />
         <?php } ?>
   <script type="text/javascript" src="<?php print get_settings('siteurl'); ?>/wp-content/plugins/ubernyms/domTT/domLib.js"></script>
   <script type="text/javascript" src="<?php print get_settings('siteurl'); ?>/wp-content/plugins/ubernyms/domTT/domTT.js"></script>
   <script type="text/javascript">
      var domTT_styleClass = 'hmoDOMTTip';
      var domTT_oneOnly = true;
      var domTT_lifetime = 4000;
      var domTT_type = 'velcro';
   </script>
   <?php
      }
   }
}

/* Simple class for ubernyms, no handling for exceptional cases, don't "mess" with it :-P */
class ubernym {
   var $type;        // One of: uttReplace, uttAbbreviation, uttAcronym, uttInitialism
   var $abbr;        // the search text
   var $text;        // the replacement text (or tooltip text)
   var $description; // additional text (in parenthesis, or in DomTT)
   var $english;     // TRUE to show the full description the first time the text appears
   var $makeLink;    // URL to convert text into a link (leave NULL to not link)
   var $appendLink;  // URL to append a (link) to the tooltip (or text if not using DomTT)

   function ubernym( $type, $abbr, $text, $description = NULL, $english = FALSE, $makeLink = NULL, $appendLink = NULL ) {
      $this->type = $type;               // One of: uttReplace, uttJustLink, uttAbbreviation, uttAcronym, uttInitialism
      $this->abbr = $abbr;               // the search text
      $this->text = $text;               // the replacement text (or tooltip text)
      $this->description = $description; // additional text (in parenthesis, or in DomTT)
      $this->english = $english;         // TRUE to show the full description the first time the text appears
      $this->makeLink = $makeLink;       // URL to convert text into a link (leave NULL to not link)
      $this->appendLink= $appendLink;    // URL to append a (link) to the tooltip (or text if not using DomTT)
   }
}
function htmlentities3($myHTML, $quote_style = ENT_QUOTES) {
	$translation_table=get_html_translation_table (HTML_ENTITIES,$quote_style);
	$translation_table[chr(38)] = '&';
	return preg_replace("/&(?![A-Za-z]{0,4}\w{2,3};|#[0-9]{2,4};)/","&amp;" , strtr($myHTML, $translation_table));
}

function ubernyms_replacer($text) {
   global $ubernyms_collection, $ubernyms_settings;
   ubernyms_load();

   $useSemanticalTags = $ubernyms_settings[0];
   $useDomTT = $ubernyms_settings[1];
   $hideTitle = $ubernyms_settings[2];
   $caseInsensitive = $ubernyms_settings[3];
   
   // put spaces on either end so we don't need special cases in our regex
   $text = " $text ";

   foreach($ubernyms_collection as $tooltip) {
      if( $tooltip->abbr > "" && $tooltip->text > "" ) {
         // need to improve this so links don't end up inside links, but PHP regex doesn't support (?<!<a[^<]*) because it only does reverse lookups that are fixed width.
         if( $caseInsensitive ) { // this first one is case-insensitive (see the i at the end?)
         // debug  echo ("\n<!-- Search For:" . $tooltip->abbr 
         // debug       ."\n   StripSlashes:" . stripslashes($tooltip->abbr)
         // debug       ."\n    HTML Decode:" . html_entity_decode(stripslashes($tooltip->abbr),ENT_QUOTES)
         // debug       ."\n R3 HTML Encode:" . htmlentities3(html_entity_decode(stripslashes($tooltip->abbr),ENT_QUOTES), ENT_COMPAT)
         // debug       ."\n    add slashes:" . addslashes(htmlentities3(html_entity_decode(stripslashes($tooltip->abbr),ENT_QUOTES), ENT_COMPAT))
         // debug       ."\n-->");

            $regex = "(?!<[^<>]*?)(?<![?./&-])\b(".addslashes(htmlentities3(html_entity_decode(stripslashes($tooltip->abbr),ENT_QUOTES), ENT_COMPAT)).")\b(?!:)(?![^<>]*?>)imsU";
         } else { // 
            $regex = "(?!<[^<>]*?)(?<![?./&-])\b(".addslashes(htmlentities3(html_entity_decode(stripslashes($tooltip->abbr),ENT_QUOTES), ENT_COMPAT)).")\b(?!:)(?![^<>]*?>)msU";
         }

         if( $tooltip->english ) { // pre-search with a single replacement and append the text.
            $text = preg_replace( $regex, $tooltip->abbr. " (".$tooltip->text.")", $text, 1 );
         }

         $class = $tooltip->type;// == uttAbbreviation ? "abbreviation" : ($tooltip->type == uttAcronym ? "acronym" : ($tooltip->type == uttInitialism ? "initialism" : "abbr" )));
         $tag  = ((($tooltip->type == uttAcronym) || !$useSemanticalTags )? '<acronym' : '<abbr').' class="'.$class.'"';
         $tag .= (( $useDomTT && $hideTitle ) ? '>': ' title="'.$tooltip->text.'">')."$1";
         $tag .= (($tooltip->type == uttAcronym) || !$useSemanticalTags )? '</acronym>' : '</abbr>';
         
         if( $tooltip->type == uttReplace ) {
            // if it's a type that calls for replace text, we replace the text.
            $tag = $tooltip->text;
         }
         if( $tooltip->type == uttJustLink ) {
            // if it's a type that just wants a link, we use the same text.
            $tag = "$1";
         }
         
         // we're NOT using the javascript library
         if( !$useDomTT ) {
            // if they want to wrap it in a link
            if( NULL != $tooltip->makeLink ) {
               // we'll wrap the $tag in <a> link
               $text = preg_replace( $regex, '<a href="'.$tooltip->makeLink.'" class="ubernym ' . $class . '">' .$tag .'</a>', $text);
            } else if( NULL != $tooltip->appendLink ){
               // we'll just tag the link on the end in the plain text.
               $text = preg_replace( $regex, $tag. '(<a class="ubernym" href="'. $tooltip->appendLink.'">link</a>)' , $text);        
            } else {
               // simple replacement.  No fancy stuff.
               $text = preg_replace( $regex, $tag, $text);
            }
         } else { // we're using the javascript library
            if( "" != $tooltip->description ) {
               $content = "'content', '". addslashes(htmlentities3(html_entity_decode($tooltip->description,ENT_QUOTES), ENT_COMPAT)) .( ( null != $tooltip->appendLink ) ? ' (&lt;a href=&quot;'. $tooltip->appendLink.'&quot;&gt;link&lt;/a&gt;)' : '' ). "','caption', '". addslashes(htmlentities(html_entity_decode($tooltip->text,ENT_QUOTES), ENT_COMPAT)) ."'";
            } else {
               $content = "'content', '". addslashes(htmlentities3(html_entity_decode($tooltip->text,ENT_QUOTES), ENT_COMPAT)) .( ( null != $tooltip->appendLink ) ? ' (&lt;a href=&quot;'. $tooltip->appendLink.'&quot;&gt;link&lt;/a&gt;)' : '' )."'";
            }
            
            // if they want to wrap it in a link
            if( NULL != $tooltip->makeLink ) {
               // we'll use the <a> link tag to host the DomTT
               $text = preg_replace( $regex, 
                  '<a href="'.$tooltip->makeLink.'" class="ubernym ' . $class . '" onmouseover="'."domTT_activate(this, event, $content );\">".
                  $tag.'</a>', $text);
            } else {
               // we'll use the <span> tag to host the DomTT // they MAY want to append a link in the DomTT description
               // debug   echo "<!-- regex[ $regex ] -->";
               // debug   echo "<!-- replace[ ". '<span class="ubernym ' . $class . '" onmouseover="'."domTT_activate(this, event, $content );\">". $tag .'</span>' ."] --> ";

               $text = preg_replace( $regex, 
                  '<span class="ubernym ' . $class . '" onmouseover="'."domTT_activate(this, event, $content );\">".
                  $tag .'</span>', $text);
            }
         }
      }
   }
   return trim( $text );
}


// add the javascript
add_action('wp_head', 'ubertt_tooltip_script'); 
// add the config menu
add_action('admin_menu', 'ubernyms_make_config_page');

// add the actual plugin to all the content we want to ubernym-ize
add_filter('the_content', 'ubernyms_replacer', 18);
add_filter('comment_text', 'ubernyms_replacer', 18);
add_filter('sidebar_content', 'ubernyms_replacer', 18);
?>